# **Tutorial para utilizar estas plantillas**

## Autores

* @tenshalito   Tuxliban Torvalds
* @lumaro       Luis

-----

## Pasos

1. Clonar este repositorio:

```
$ git -C "$HOME/repositorios_git" clone https://git.disroot.org/tuxliban/tutoriales_void/src/branch/suckless-git --depth 1
```

2. Para poder crear paquetes personalizado en Void Linux es necesario clonar también el repositorio de *void-packages* e instalar los paquetes de arranque con las últimas versiones disponibles:

```
$ git -C "$HOME/repositorios_git" clone https://github.com/void-linux/void-packages.git --depth 1
$ cd "$HOME/repositorios_git"/void-packages
$ ./xbps-src binary-bootstrap
```

**Nota:** Si ya tienen clonado el repositorio de *void-packages* omitir este paso

3. Copiar el directorio del paquete que quieren al directorio `srcpkgs` del repositorio de *void-packages*. Para nuestro ejemplo utilizaremos la plantilla para el paquete de la terminal *st-git*:

* Primero copiamos el directorio:

```
$ cp "$HOME"/repositorios_git/tutoriales_void/Plantillas/suckless-git/st-git "$HOME"/repositorios_git/void-packages/srcpkgs
```

* El siguiente paso solo aplica para la plantilla de *st-git*

```
$ cd "$HOME"/repositorios_git/void-packages/srcpkgs
$ ln -s st-git st-terminfo-git
```

* A continuación, proceder a construir el paquete:

```
$ cd "$HOME"/repositorios_git/void-packages
./xbps-src pkg st-git
```

**Nota:** si desean acelerar el proceso de compilación especificarle a `xbps-src` cuántos *jobs* se usarán para la construcción en paralelo:

```
./xbps-src -j # pkg st-git
```

Donde `#` se reemplaza según el número de unidades de procesamiento disponibles devueltos por `nproc`

* Ahora lo que resta por hacer es instalar el paquete que se ha construido. Se recomienda hacerlo a través del comando `xi`. Si el comando no está disponible en el PATH significa que no está instalado, por lo tanto instalar el paquete `xtools`

```
$ xi -y st-git
```
## Notas finales

* Todas las plantillas están configuradas para que en caso de existir una configuración personalizada del fichero `config.h` sea leido durante el proceso de compilación. Si el usuario cuenta con dicha configuración, crear un directorio llamado *files* dentro del directorio que contiene a la plantilla. Ejemplo:

```
mkdir "$HOME"/repositorios_git/void-packages/srcpkgs/PAQUETE-git/files
```

Después colocar en ese directorio el fichero y continuar con el punto tres del paso tres

* Si desea aplicar algún parche realizar el mismo procedimiento del punto anterior, pero en lugar de crear un directorio llamado *files* ahora nombrarlo como *patches* y colocar ahí el o los parches que desea usar:

```
mkdir "$HOME"/repositorios_git/void-packages/srcpkgs/PAQUETE-git/patches
```

Por último, todo este procedimiento aplica para poder instalar cualquier otro paquete en la versión git de las plantillas de suckless de este repositorio
